<?php
/**
 * @file
 */

/**
 *
 * @param $form
 * @param $form_state
 *
 * @return mixed
 */
function open_weixin_user_info($form, &$form_state) {

  global $user;
  $profile = profile2_load_by_user($user, __OPEN_WEIXIN);
  $wrapper = entity_metadata_wrapper('profile2', $profile);

  // User can't only change username one time, in case of they make up fake username.
  if ($wrapper->open_weixin_is_named->value() == TRUE){
    $open_weixin_landing_login = open_weixin_array_variable_get(OPEN_WEIXIN__VARIABLES, 'open_weixin_landing_login', 'user');
    drupal_set_message(t('Only new Open Weixin user could change username.'), 'warning');
    drupal_goto($open_weixin_landing_login);
  }

  global $user;
  $current_name = ($user->name === $user->uid)?'':$user->name;

  $form['name'] = array(
    '#title' => t('Username'),
    '#type' => 'textfield',
    '#description' => t('Once chance to customize your username, username must be unique, punctuation is not allowed except for periods, hyphens, apostrophes, and underscores.'),
    '#default_value' => $current_name,
  );
  $form['actions']['#type'] = 'actions';
  $form['actions']['submit'] = array('#type' => 'submit', '#value' => t('Save'));

  return $form;
}

function open_weixin_user_info_validate ($form, &$form_state){
  global $user;
  $account = $user;

  if (isset($form_state['values']['name'])) {
    if ($error = user_validate_name($form_state['values']['name'])) {
      form_set_error('name', $error);
    }
    elseif ((bool) db_select('users')->fields('users', array('uid'))->condition('uid', $account->uid, '<>')->condition('name', db_like($form_state['values']['name']), 'LIKE')->range(0, 1)->execute()->fetchField()) {
      form_set_error('name', t('The name %name is already taken.', array('%name' => $form_state['values']['name'])));
    }
  }
}

/**
 * @param $form
 * @param $form_state
 *
 * @throws \Exception
 */
function open_weixin_user_info_submit($form, &$form_state){
  $values = $form_state['values'];

  global $user;

  user_save($user, array(
    'name' => $values['name'],
  ));

  $profile = profile2_load_by_user($user, __OPEN_WEIXIN);
  $wrapper = entity_metadata_wrapper('profile2', $profile);
  $wrapper->open_weixin_is_named->set(TRUE);
  $wrapper->save(TRUE);

  $open_weixin_landing_login = open_weixin_array_variable_get(OPEN_WEIXIN__VARIABLES, 'open_weixin_landing_login', 'user');
  drupal_set_message(t('Username has been saved.'));
  drupal_goto($open_weixin_landing_login);
}
